/*
    Copyright (C) 2005, 2006  Vansteenhuyse Hubert <hvansteenhuyse@yahoo.com>

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#include "CHexEd.h"
#include <sys/stat.h>
CBuffer::CBuffer(char *path, int swRO) : ioLowLevel() {
    IsCopy = 0;
    mPath = new CStr();
    mPath->append(path);
    mBuf = 0;
    mBufSize = 0;
    mBuf = (char*)malloc(mBufSize);
    mf = ioOpenFile(path, 0);
    mSwRO = 1;
    mFileSize = 0;
    if(!err()) mFileSize = ioFileSize(mf);
    mBufTail = 0;
    mFileAddress = 0;
    mSwEof = 0;
}

CBuffer::~CBuffer(){
    delete mPath;
    if(!IsCopy && mf) ioCloseFile(mf);
    if(mBuf)free(mBuf);
    mf = 0;
}

//copies filehandler and path from base...
CBuffer::CBuffer(CBuffer *base) : ioLowLevel() {
    IsCopy = 1;
    mPath = new CStr();
    mPath->append(base->mPath->get());
    mBuf = 0;
    mBufSize = 0;
    mBuf = (char*)malloc(mBufSize);
    mSwRO = base->mSwRO;
    mf = base->mf;
    mFileSize = base->mFileSize;
    mBufTail = 0;
    mFileAddress = 0;
    mSwEof = 0;
    seterr(0);
}

long CBuffer::ReadFrom(unsigned long fileaddress, long amount){
    if(!mf || !amount) return 0;
    if(amount > 0 && (fileaddress + amount) > mFileSize && mSwEof) return mBufTail;
    if(amount < 0 && fileaddress > mFileSize) fileaddress = 0;
    if(amount < 0) amount *= -1;

    mBufTail = 0;
    if(mBufSize != amount){
        mBufSize = 0;
        if(!mBuf)
            mBuf = (char*)malloc(amount);
        else
            mBuf = (char*)realloc(mBuf, amount);
    }
    if(mBuf){
        mBufSize = amount;
        if(-1 != ioSeekFile(mf, fileaddress)){
            mBufTail = ioReadFile(mf, mBuf, mBufSize);
            mFileAddress = fileaddress + mBufTail;
            mSwEof = ioIsEofFile(mf);
        }
    }
    //log("CBuffer::ReadFrom >> Errno %d, mSwEof = %s, FileAddress 0x%d, BufTail %d,  amount asked %d", errno,(mSwEof ? "true" : "false"), mFileAddress, mBufTail, amount);
    return mBufTail;
}

long CBuffer::WriteFile(unsigned long fileaddress, char *buf, long amount){
    long res = 0;
    unsigned long savefileaddress = mFileAddress;

    if(!mf || !amount) return res;
    if(-1 != ioSeekFile(mf, fileaddress)){
        errno = 0;
        res = ioWriteFile(mf, buf, amount);
        if(!errno){
          ioFlushFile(mf);
          ReadFrom(savefileaddress - mBufTail, mBufTail);
        }
    }
    //log("fwrite errno: %d, written at 0x%X(#%d bytes)", errno, fileaddress, res);
    return res;
}

